package com.fp.persistence.parmas.soli;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMSOLICITUDDOCUMENTO*/
@Embeddable
public class TarmSolicitudDocumentoKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CDOCUMENTO", nullable=false,updatable=false)

/**
* Codigo secuencial del documento habilitante
*/
private Long cdocumento;

@Column(name="CSOLICITUD", nullable=false,updatable=false)

/**
* Codigo de solicitud
*/
private String csolicitud;

/**Contructor por defecto*/
public TarmSolicitudDocumentoKey(){}
/**Contructor de TarmSolicitudDocumentoKey
@param pCdocumento Codigo secuencial del documento habilitante
@param pCsolicitud Codigo de solicitud
*/
public TarmSolicitudDocumentoKey(Long pCdocumento,String pCsolicitud){
 cdocumento=pCdocumento;
 csolicitud=pCsolicitud;
}
/**Obtiene el valor de cdocumento
@return valor de cdocumento*/
public Long getCdocumento(){
  return cdocumento;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setCdocumento(Long pCdocumento){
  cdocumento=pCdocumento;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Implementacion de la comparacion de TarmSolicitudDocumentoKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmSolicitudDocumentoKey))return false;
  TarmSolicitudDocumentoKey that = (TarmSolicitudDocumentoKey) o;
  if (this.getCdocumento() == null || that.getCdocumento() == null){
      return false;
  }
  if (! this.getCdocumento().equals(that.getCdocumento())){
    return false;
  }
  if (this.getCsolicitud() == null || that.getCsolicitud() == null){
      return false;
  }
  if (! this.getCsolicitud().equals(that.getCsolicitud())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmSolicitudDocumentoKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCdocumento() == null ? 0 : this.getCdocumento().hashCode());
    result = result * 37 + (this.getCsolicitud() == null ? 0 : this.getCsolicitud().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
